#pragma once

// C++ system level
#include <vector>
// #include <cstring>     // memset, strncmp
// #include <cstdlib>     // TODO: is this for memcpy?
// #include <functional>

// ESP32 specific
#include "esp_log.h"

// project specific
#include <Types.hpp>
#include "Service.hpp"
#include "SiliconTorch/FxCyanF.hpp"

// qthing stuff
// #include <qthing>

// misc
#include <nlohmann/json.hpp>


namespace SiliconTorch {

  namespace Service {


    class FxCyanF : public ServiceManager::Service {

      public:

        void init();

        void start();

        ::SiliconTorch::FxCyanF::FxCyanF* getFxCyanF() const;

        virtual nlohmann::json getConfigJSON() const;

      private:

        ::SiliconTorch::FxCyanF::FxCyanF* fxCyan = NULL;

        nlohmann::json savedCfg;

    };

  }
}
